9ae3a8
From 5fe07e00b182e79e2e8095916d18cc0f37348efe Mon Sep 17 00:00:00 2001
9ae3a8
From: Max Reitz <mreitz@redhat.com>
9ae3a8
Date: Fri, 2 May 2014 16:06:21 +0200
9ae3a8
Subject: [PATCH 03/31] qemu-iotests: Discard preallocated zero clusters
9ae3a8
9ae3a8
RH-Author: Max Reitz <mreitz@redhat.com>
9ae3a8
Message-id: <1399046781-16359-3-git-send-email-mreitz@redhat.com>
9ae3a8
Patchwork-id: 58645
9ae3a8
O-Subject: [RHEL-7.0 qemu-kvm PATCH 2/2] qemu-iotests: Discard preallocated zero clusters
9ae3a8
Bugzilla: 1052093
9ae3a8
RH-Acked-by: Kevin Wolf <kwolf@redhat.com>
9ae3a8
RH-Acked-by: Stefan Hajnoczi <stefanha@redhat.com>
9ae3a8
RH-Acked-by: Jeffrey Cody <jcody@redhat.com>
9ae3a8
9ae3a8
BZ: 1052093
9ae3a8
9ae3a8
Add a new test case for discarding preallocated zero clusters; doing
9ae3a8
this should not result in any leaks.
9ae3a8
9ae3a8
Signed-off-by: Max Reitz <mreitz@redhat.com>
9ae3a8
Signed-off-by: Kevin Wolf <kwolf@redhat.com>
9ae3a8
(cherry picked from commit 975a93c082452db9aa1397a797ca8f13ba367393)
9ae3a8
9ae3a8
Conflicts:
9ae3a8
	tests/qemu-iotests/group
9ae3a8
9ae3a8
Signed-off-by: Max Reitz <mreitz@redhat.com>
9ae3a8
---
9ae3a8
 tests/qemu-iotests/066     | 63 ++++++++++++++++++++++++++++++++++++++++++++++
9ae3a8
 tests/qemu-iotests/066.out | 13 ++++++++++
9ae3a8
 tests/qemu-iotests/group   |  1 +
9ae3a8
 3 files changed, 77 insertions(+)
9ae3a8
 create mode 100755 tests/qemu-iotests/066
9ae3a8
 create mode 100644 tests/qemu-iotests/066.out
9ae3a8
9ae3a8
Signed-off-by: Miroslav Rezanina <mrezanin@redhat.com>
9ae3a8
---
9ae3a8
 tests/qemu-iotests/066     |   63 ++++++++++++++++++++++++++++++++++++++++++++
9ae3a8
 tests/qemu-iotests/066.out |   13 +++++++++
9ae3a8
 tests/qemu-iotests/group   |    1 +
9ae3a8
 3 files changed, 77 insertions(+), 0 deletions(-)
9ae3a8
 create mode 100755 tests/qemu-iotests/066
9ae3a8
 create mode 100644 tests/qemu-iotests/066.out
9ae3a8
9ae3a8
diff --git a/tests/qemu-iotests/066 b/tests/qemu-iotests/066
9ae3a8
new file mode 100755
9ae3a8
index 0000000..1c2452b
9ae3a8
--- /dev/null
9ae3a8
+++ b/tests/qemu-iotests/066
9ae3a8
@@ -0,0 +1,63 @@
9ae3a8
+#!/bin/bash
9ae3a8
+#
9ae3a8
+# Test case for discarding preallocated zero clusters in qcow2
9ae3a8
+#
9ae3a8
+# Copyright (C) 2013 Red Hat, Inc.
9ae3a8
+#
9ae3a8
+# This program is free software; you can redistribute it and/or modify
9ae3a8
+# it under the terms of the GNU General Public License as published by
9ae3a8
+# the Free Software Foundation; either version 2 of the License, or
9ae3a8
+# (at your option) any later version.
9ae3a8
+#
9ae3a8
+# This program is distributed in the hope that it will be useful,
9ae3a8
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
9ae3a8
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
9ae3a8
+# GNU General Public License for more details.
9ae3a8
+#
9ae3a8
+# You should have received a copy of the GNU General Public License
9ae3a8
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
9ae3a8
+#
9ae3a8
+
9ae3a8
+# creator
9ae3a8
+owner=mreitz@redhat.com
9ae3a8
+
9ae3a8
+seq="$(basename $0)"
9ae3a8
+echo "QA output created by $seq"
9ae3a8
+
9ae3a8
+here="$PWD"
9ae3a8
+tmp=/tmp/$$
9ae3a8
+status=1	# failure is the default!
9ae3a8
+
9ae3a8
+_cleanup()
9ae3a8
+{
9ae3a8
+	_cleanup_test_img
9ae3a8
+}
9ae3a8
+trap "_cleanup; exit \$status" 0 1 2 3 15
9ae3a8
+
9ae3a8
+# get standard environment, filters and checks
9ae3a8
+. ./common.rc
9ae3a8
+. ./common.filter
9ae3a8
+
9ae3a8
+# This tests qocw2-specific low-level functionality
9ae3a8
+_supported_fmt qcow2
9ae3a8
+_supported_proto generic
9ae3a8
+_supported_os Linux
9ae3a8
+
9ae3a8
+IMGOPTS="compat=1.1"
9ae3a8
+IMG_SIZE=64M
9ae3a8
+
9ae3a8
+echo
9ae3a8
+echo "=== Testing snapshotting an image with zero clusters ==="
9ae3a8
+echo
9ae3a8
+_make_test_img $IMG_SIZE
9ae3a8
+# Write some normal clusters, zero them (creating preallocated zero clusters)
9ae3a8
+# and discard those
9ae3a8
+$QEMU_IO -c "write 0 256k" -c "write -z 0 256k" -c "discard 0 256k" "$TEST_IMG" \
9ae3a8
+         | _filter_qemu_io
9ae3a8
+# Check the image (there shouldn't be any leaks)
9ae3a8
+_check_test_img
9ae3a8
+
9ae3a8
+# success, all done
9ae3a8
+echo "*** done"
9ae3a8
+rm -f $seq.full
9ae3a8
+status=0
9ae3a8
diff --git a/tests/qemu-iotests/066.out b/tests/qemu-iotests/066.out
9ae3a8
new file mode 100644
9ae3a8
index 0000000..9139780
9ae3a8
--- /dev/null
9ae3a8
+++ b/tests/qemu-iotests/066.out
9ae3a8
@@ -0,0 +1,13 @@
9ae3a8
+QA output created by 066
9ae3a8
+
9ae3a8
+=== Testing snapshotting an image with zero clusters ===
9ae3a8
+
9ae3a8
+Formatting 'TEST_DIR/t.IMGFMT', fmt=IMGFMT size=67108864 
9ae3a8
+wrote 262144/262144 bytes at offset 0
9ae3a8
+256 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
9ae3a8
+wrote 262144/262144 bytes at offset 0
9ae3a8
+256 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
9ae3a8
+discard 262144/262144 bytes at offset 0
9ae3a8
+256 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
9ae3a8
+No errors were found on the image.
9ae3a8
+*** done
9ae3a8
diff --git a/tests/qemu-iotests/group b/tests/qemu-iotests/group
9ae3a8
index ad96fcf..1c91036 100644
9ae3a8
--- a/tests/qemu-iotests/group
9ae3a8
+++ b/tests/qemu-iotests/group
9ae3a8
@@ -68,6 +68,7 @@
9ae3a8
 063 rw auto
9ae3a8
 064 rw auto
9ae3a8
 065 rw auto
9ae3a8
+066 rw auto
9ae3a8
 067 rw auto
9ae3a8
 068 rw auto
9ae3a8
 070 rw auto
9ae3a8
-- 
9ae3a8
1.7.1
9ae3a8